;--------------------------------------------------------------------------------------------------
;All objects change coordinats z to zero
;this lisp was added with some more entities by nuno da silva <pirilao@gmx.net>
(defun c:nat_allzero ()
        (setq nv_allelements (entnext))

       (while nv_allelements
          (setq nv_e_liste (entget nv_allelements))
          (setq nv_e_name (cdr (assoc 0 nv_e_liste)))
          (cond
            ((= nv_e_name "LINE")(= nv_e_name "TEXT")(z_0_linie))
            ((or  (= nv_e_name "ARC")
                  (= nv_e_name "CIRCLE")
                  (= nv_e_name "POINT")
                  (= nv_e_name "INSERT")
                  (= nv_e_name "HATCH")
                  (= nv_e_name "ELLIPSE")
                  (= nv_e_name "SOLID")
                  (= nv_e_name "VERTEX")
                  (= nv_e_name "MTEXT")
                  (= nv_e_name "TEXT")
                  (= nv_e_name "POLYLINE"))(Z_0_BKP))
            ((or  (= nv_e_name "ATTRIB")) (z_0_attr))
;            ((or  (= nv_e_name "SPLINE")) (z_0_spline))
            ((or  (= nv_e_name "DIMENSION")) (z_0_dim))
            ((or  (= nv_e_name "LWPOLYLINE")) (z_0_lwpl))
          ;;
          );end cond
          (setq nv_allelements (entnext nv_allelements))
       );end while
 (princ)(princ)
);end defun

;Unterprogramm
(defun Z_0_linie (  / ax1 ax2 ax3 ax4 ay1 ay2 ay3 ay4)

       (setq ax1 (nth 0 (assoc 10 nv_e_liste)))
       (setq ax2 (nth 1 (assoc 10 nv_e_liste)))
       (setq ax3 (nth 2 (assoc 10 nv_e_liste)))
       (setq ax4 0.0)
       (setq nv_e_liste (subst (list ax1 ax2 ax3 ax4)(assoc 10 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq ay1 (nth 0 (assoc 11 nv_e_liste)))
       (setq ay2 (nth 1 (assoc 11 nv_e_liste)))
       (setq ay3 (nth 2 (assoc 11 nv_e_liste)))
       (setq ay4 0.0)
       (setq nv_e_liste (subst (list ay1 ay2 ay3 ay4) (assoc 11 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (princ)
);end defun
;Unterprogramm
(defun z_0_spline (  / nv_ax1 nv_ax2 nv_ax3 nv_ax4
                       nv_ay1 nv_ay2 nv_ay3 nv_ay4
                       nv_z                        )

;;    (setq nv_z (cdr (assoc 73 nv_e_liste)))  ;anzahl der Kontrollpunkte
;; info---------------->  assoc 74 nv_e_liste      wrde die anzahl der Angleichungspunkte liefern


;;   (repeat nv_z 

         (setq nv_ax1 (nth 0 (assoc 10 nv_e_liste)))
         (setq nv_ax2 (nth 1 (assoc 10 nv_e_liste)))
         (setq nv_ax3 (nth 2 (assoc 10 nv_e_liste)))
         (setq nv_ax4 0.0)
         (setq nv_e_liste (subst (list nv_ax1 nv_ax2 nv_ax3 nv_ax4)(assoc 10 nv_e_liste) nv_e_liste))
         (entmod nv_e_liste)

         (setq nv_ay1 (nth 0 (assoc 11 nv_e_liste)))
         (setq nv_ay2 (nth 1 (assoc 11 nv_e_liste)))
         (setq nv_ay3 (nth 2 (assoc 11 nv_e_liste)))
         (setq nv_ay4 0.0)
         (setq nv_e_liste (subst (list nv_ay1 nv_ay2 nv_ay3 nv_ay4) (assoc 11 nv_e_liste) nv_e_liste))
         (entmod nv_e_liste)
;;   );ende repeat
  (entupd nv_allelements)
  (princ)
);end defun
;Unterprogram
(defun z_0_lwpl ( / lwplz)   ;lwpolylinien bearbeiten

       (setq lwplz 0.0)      ; z-koordinate festlegen
       (setq nv_e_liste (subst (cons 38 lwplz) (assoc 38 nv_e_liste) nv_e_liste))  ;erhebung z auf variablenkoordinate setzen
       (entmod nv_e_liste)   ;modifizieren der entities

);end z_0_lwpl
;
(defun z_0_dim (  / bx1 bx2 bx3 bx4 by1 by2 by3 by4
                    cx1 cx2 cx3 cx4 cy1 cy2 cy3 cy4
                    dx1 dx2 dx3 dx4 dy1 dy2 dy3 dy4
                    gx1 gx2 gx3 gx4                )

       (setq bx1 (nth 0 (assoc 10 nv_e_liste)))
       (setq bx2 (nth 1 (assoc 10 nv_e_liste)))
       (setq bx3 (nth 2 (assoc 10 nv_e_liste)))
       (setq bx4 0.0)
       (setq nv_e_liste (subst (list bx1 bx2 bx3 bx4)(assoc 10 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq by1 (nth 0 (assoc 11 nv_e_liste)))
       (setq by2 (nth 1 (assoc 11 nv_e_liste)))
       (setq by3 (nth 2 (assoc 11 nv_e_liste)))
       (setq by4 0.0)
       (setq nv_e_liste (subst (list by1 by2 by3 by4) (assoc 11 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq cx1 (nth 0 (assoc 12 nv_e_liste)))
       (setq cx2 (nth 1 (assoc 12 nv_e_liste)))
       (setq cx3 (nth 2 (assoc 12 nv_e_liste)))
       (setq cx4 0.0)
       (setq nv_e_liste (subst (list cx1 cx2 cx3 cx4) (assoc 12 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq cy1 (nth 0 (assoc 13 nv_e_liste)))
       (setq cy2 (nth 1 (assoc 13 nv_e_liste)))
       (setq cy3 (nth 2 (assoc 13 nv_e_liste)))
       (setq cy4 0.0)
       (setq nv_e_liste (subst (list cy1 cy2 cy3 cy4) (assoc 13 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq dx1 (nth 0 (assoc 14 nv_e_liste)))
       (setq dx2 (nth 1 (assoc 14 nv_e_liste)))
       (setq dx3 (nth 2 (assoc 14 nv_e_liste)))
       (setq dx4 0.0)
       (setq nv_e_liste (subst (list dx1 dx2 dx3 dx4) (assoc 14 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq dy1 (nth 0 (assoc 15 nv_e_liste)))
       (setq dy2 (nth 1 (assoc 15 nv_e_liste)))
       (setq dy3 (nth 2 (assoc 15 nv_e_liste)))
       (setq dy4 0.0)
       (setq nv_e_liste (subst (list dy1 dy2 dy3 dy4) (assoc 15 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq gx1 (nth 0 (assoc 16 nv_e_liste)))
       (setq gx2 (nth 1 (assoc 16 nv_e_liste)))
       (setq gx3 (nth 2 (assoc 16 nv_e_liste)))
       (setq gx4 0.0)
       (setq nv_e_liste (subst (list gx1 gx2 gx3 gx4) (assoc 16 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (princ)
);end defun
;Unterprogramm
(defun Z_0_BKP ( /  arx1 arx2 arx3 arx4)

       (setq arx1 (nth 0 (assoc 10 nv_e_liste)))
       (setq arx2 (nth 1 (assoc 10 nv_e_liste)))
       (setq arx3 (nth 2 (assoc 10 nv_e_liste)))
       (setq arx4 0.0)
       (setq nv_e_liste (subst (list arx1 arx2 arx3 arx4) (assoc 10 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

 (princ)
);end defun subroutine z_0_bkp
;Unterprogramm
(defun Z_0_attr ( /  atr1 atr2 atr3 atr4 atr5)

       (setq atr1 (nth 0 (assoc 10 nv_e_liste)))
       (setq atr2 (nth 1 (assoc 10 nv_e_liste)))
       (setq atr3 (nth 2 (assoc 10 nv_e_liste)))
       (setq atr4 0.0)
       (setq nv_e_liste (subst (list atr1 atr2 atr3 atr4) (assoc 10 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)

       (setq atr5 0.0)
       (setq nv_e_liste (subst (cons 30 atr5) (assoc 30 nv_e_liste) nv_e_liste))
       (entmod nv_e_liste)
       (entupd nv_allelements)
 (princ)
);end defun subroutine z_0_attr
;;ende nat_allzero
(princ "\nCommand = NAT_ALLZERO\n")